#ifndef  _ADGLOBALS_
#define  _ADGLOBALS_

/* global variables for automatic synthesis of switched-capacitor circuits */
/* Author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* Last Change: 7/11/87 */

/*
 * Modifications to Adore
 * Henry Chang (henryc@ic.Berkeley.EDU)
 * Fall, 1990
 */

#include "ADstr.h"

extern int Numinteg;
extern int Numcblk;
extern int Numcap;
extern int Numnet;
extern int Numsw;
extern int Numclk;
extern int Numterm;

extern struct _module *modlist[NUMMODTYPES];
extern struct _net *netlist;
extern struct _net **ordered_nets; /*list nets orderd according to net number */
extern struct _channel *chanlist[MAXNUMCH];
extern struct _lib *liblist;

extern int gerror; /* global error flag */

extern int hcc_debug_flg;		/* declared in ADmain.c */
extern int verbose_flg;			/* declared in ADmain.c */

/* General Definitions */
#define VERBOSE(fct) \
    ( verbose_flg == 0 ) ? 0 : fct
#define DEBUG(fct) \
    ( hcc_debug_flg == 0 ) ? 0 : fct
#define SYSTEM(call) \
    if ( system (call) != 0 ) \
        errRaise (C_FILE_NAME, 0, "system(\"%s\") error", call)

#define  strdup(x)    (char *) util_strsav(x)

/* The following macro lambda-aligns the coordinates
 */
#define   LAMBDA_ROUND(x)    { x = ((int) (x/20)) * 20; }
#define   coordSize     20

#endif
