/* finds the unit capacitor area per capacitor block for adore2 */
/* Author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* Last Change: 8/13/87 */

#include "ADglobals.h"
#include "TEKtech.h"
#include <stdio.h>

CBLKucapArea()
{
  double unitsize;

  struct _module *tmpmod;
  struct _cblk *tmpcblk;

  for ( tmpmod = modlist[CBLK]; tmpmod != NULL; tmpmod = tmpmod->next ) {
    tmpcblk = tmpmod->info.cblk;
    if ( tmpcblk->integcap == NULL ) {
      printf("CBLKucapArea: A block with no integrating capacitor\n");
      gerror = ON;
    }
    else {
      unitsize = tmpcblk->integcap->size / tmpcblk->integcap->ratio;
      tmpcblk->unitA = 10000. * unitsize / cap_per_ua;
    }
  }
}
