/* find the channel of the overall circuit terminals for adore2 */ 
/* Author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* Last Change: 8/4/87 */

/* defined: INPcktTerm, INPclkTerm*/


#include "ADglobals.h"
#include <stdio.h>

INPcktTerm( module )
struct _module *module;
{
	int termtype;
	struct _terminal *tmpterm, *netterm;
	struct _terminal *dumterm, *INPcrtTerm();


	if ( module == modlist[INMOD] ) {
		termtype = INPUT;
	}
	else if ( module == modlist[OUTMOD] ) {
		termtype = OUTPUT;
	}
	else {
		fprintf(stderr,"INPcktTerm;1: internal error\n");
		exit(-1);
	}

	/* initialize the geometric information */
	module->xtrans = module->xsep = module->xdim = 0;

	tmpterm = module->terminals;
	for ( ; tmpterm != NULL; tmpterm = tmpterm->next ) {
		if ( tmpterm->channel != NULL ) {
			/* this is a newly created terminal */
			continue;
		}
		netterm = tmpterm->netptr->firstnett;
		for ( ; netterm != NULL; netterm = netterm->nxtnett ) {
			if ( netterm->channel == NULL ) {
				continue;
			}

			if ( netterm->channel != chanlist[TOP] && 
								  netterm->channel != chanlist[BOTTOM] ) {
				fprintf(stderr,"INPcktTerm;1: internal error\n");
				exit(-1);
			}

			if ( tmpterm->channel == NULL ) {
				tmpterm->channel = netterm->channel;
				continue;
			}

			if ( tmpterm->channel != netterm->channel ) {
				/* need to create a new terminal */
				dumterm = INPcrtTerm(tmpterm->netptr, netterm->channel,
												termtype, module, NULL );
				break;
			}
		}
	}
}

/* Add the clk inputs to INMOD */
INPclkTerm()
{
	struct _net *tmpnet;
	struct _terminal *tmpterm, *INPcrtTerm();


	for ( tmpnet = netlist; tmpnet != NULL; tmpnet = tmpnet->next ) {
		if ( tmpnet->type == CLOCK ) {
			tmpterm = INPcrtTerm(tmpnet, chanlist[CLKCH], INPUT,
										 modlist[INMOD],NULL );
			strcpy( tmpterm->name, tmpnet->name );
		}
	}
}
