/*
 * Copyright (c) 1985 Thomas L. Quarles
 */
#ifndef LINT
static char rcsid[] =
    "INPgetTok.c $Revision: 7.1 $ on $Date: 86/03/31 11:50:46 $";
#endif LINT
    /* get input token from 'line', 
     *  and return a pointer to it in 'token'
     */

#define E_NOMEM 1
#define OK 0

#include <stdio.h>
#include "utility.h"
#include "INPdefs.h"

int
  INPgetTok(line,token)
char ** line;
char ** token;
{
    char * point;
    /* scan along throwing away garbage characters */
    for(point = *line;*point != '\0' ; point++ ) {
        if(*point == ' ') continue;
        if(*point == '\t') continue;
        if(*point == '=') continue;
        if(*point == '(') continue;
        if(*point == ')') continue;
        if(*point == ',') continue;
        break;
    }
    /* mark beginning of token */
    *line = point;
    /* now find all good characters */
    for(point = *line;*point!='\0';point++) {
        if(*point == ' ') break;
        if(*point == '\t') break;
        if(*point == '=') break;
        if(*point == '(') break;
        if(*point == ')') break;
        if(*point == ',') break;
    }
    *token = ALLOC(char, 1+point-*line);
    if(!*token) return(E_NOMEM);
    (void) strncpy(*token,*line,point-*line);
    *(*token + (point-*line)) = '\0';
    *line = point;
    /* gobble garbage to next token */
    for( ;**line != '\0' ; (*line)++ ) {
        if(**line == ' ') continue;
        if(**line == '\t') continue;
        if(**line == '=') continue;
        if(**line == '(') continue;
        if(**line == ')') continue;
        if(**line == ',') continue;
        break;
    }
    /*printf("found token (%s) and rest of line (%s)\n",*token,*line);*/
    return(OK);
}
