/* this is the input parser for the switched-capacitor layout program */
/* Author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* Last Change : 7/13/87 */

/*
 * Modifications to Adore
 * Henry Chang (henryc@ic.Berkeley.EDU)
 * Fall, 1990
 */

#include <stdio.h>
#include "INPdefs.h"
#include "ADglobals.h"

/*
 * fpin, File Pointer to the cktfile.
 * fpout, File Pointer to cktoutfile.
 */

INPsetupAll(fpin, fpout, lib)
FILE *fpin, *fpout;
char *lib;				/* directory name for library      */
{
	card *deck;

	INPinitGlb(); 			/* initialize the global variables */

	INPreadAll(fpin, &deck);	/* Reads in Input File             */
					/* Not check thoroughly-hcc        */

	INPpass2(deck,lib);		/* Builds linked lists from input  */
					/* Not check thoroughly-hcc        */

	INPlist(fpout, deck, PHYSICAL); /* Creates CKTOUT_TMP_FILE	   */

	INPcktCheck(lib);		/* Crates lots of symbol tables    */
                                        /* Checked thorouhly -hcc	   */
	INPcktTerm(modlist[INMOD]);
	INPcktTerm(modlist[OUTMOD]);
	INPclkTerm();
	INPinitOrd();
	INPordNets();
	INPmergeAllTP();

	DEBUG (printf("numnet=%d, numinteg=%d, numcap=%d, numsw=%d\n",
					   Numnet, Numinteg, Numcap, Numsw));
}
