/* the main procedure for processing a given channel, for adore2 */
/* Author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* last change: 7/30/87 */

/*
 * Modifications to Adore
 * Henry Chang (henryc@ic.Berkeley.EDU)
 * Fall, 1990
 */

#define C_FILE_NAME "ROUTdoAll.c"

#include "ADglobals.h"
#include "ROUTglobals.h"
#include "TEKtech.h"
#include <stdio.h>

/* for mighty only */
#define FALSE 0
#define TRUE 1

int debug;

ROUTdoAll ( channel,tmp_dir,instances )
struct _channel *channel; 
char *tmp_dir;
char *instances;
{
  int argc;			/* used by mighty */
  char *argv[10];

  int numrow, numcol;
  int chx, chy;

  int chflag;			/*indicates whether the channel routing was completed */
  int h_increase;		/* number of times the channel height increases */

  char tmpname[40], *chname, *CBLKpushDir();
  FILE *fopen(), *fp;

  char unix_command[UNIX_COMMAND_SIZE];

  debug = YES;

  ROUTassCol( channel );
  ROUTchDens( channel );

  /* initialize number of tracks */
  channel->lowchy = 0;
  channel->hichy = channel->maxdensity + 1;

  numcol = channel->hichx - channel->lowchx + 1;
  numrow = channel->hichy - channel->lowchy + 10;
  CALLOC(channel->ch_matrix, numcol, struct _ch_matrix *);
  for ( chx = channel->lowchx; chx <= channel->hichx; chx++ ) {
    CALLOC(channel->ch_matrix[chx], numrow, struct _ch_matrix);
  }

		
  chflag = FAILURE;
  h_increase = 0;

  while ( chflag == FAILURE ) {

    ROUTtermChy( channel );
    ROUTchrInput( channel, tmp_dir );

    for ( chx = channel->lowchx; chx <= channel->hichx; chx++ ) {
      for ( chy = channel->lowchy; chy <= channel->hichy; chy++ ) {
	channel->ch_matrix[chx][chy].via = NULL;
	channel->ch_matrix[chx][chy].snet_stack = NULL;
      }
    }

    /*** mighty included in the program */
    /*
      argc = 3;
      argv[0] = "mighty"; argv[1] = "_ch.in"; argv[2] = "_ch.out";
      mighty( argc, argv );
      */
    sprintf (unix_command,"mighty %s/%s %s/%s",tmp_dir,
	     CH_IN_FILE, tmp_dir, CH_OUT_FILE);
    /* SYSTEM(unix_command); */
    if ( system(unix_command)!=0 ) {
	printf ("%s: system(\"%s\") error.  Continuing...\n",
	    C_FILE_NAME, unix_command);
    }

    chflag = ROUTchrOut( channel, tmp_dir );

    if ( chflag == FAILURE ) {
      channel->hichy++;
      h_increase++;
      if ( h_increase > 9 ) {
	/* 
         * fprintf(stderr,"ROUTdoAll: router failed\n");
	 * exit(-1);
         * -hcc
         */
	printf ("ROUTdoAll: router failed, continuing...");
      }
    }
  }

  channel->module->ydim = minctctsp * (channel->hichy - channel->lowchy);

  ROUTgenLay( channel,instances );


  if ( shieldflag == YES && channel->name != CLKCH ) {

    ROUTshieldIn(channel,tmp_dir);

    /*
      argc = 3;
      argv[0] = "mighty"; argv[1] = "_sh.in"; argv[2] = "_sh.out";
      mighty( argc, argv );
      if (mighty( argc, argv ) == TRUE) 
      */
    sprintf (unix_command,"mighty %s/%s %s/%s",tmp_dir,
	     SH_IN_FILE, tmp_dir, SH_OUT_FILE);
    /* SYSTEM(unix_command); */
    if ( system(unix_command)!=0 ) {
	printf ("%s: system(\"%s\") error.  Continuing...\n",
	    C_FILE_NAME, unix_command);
    }

    ROUTshieldOut(channel,tmp_dir);
  }
}
