/* make vertical connections from capacitor terminals to the channels */
/* Author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* last change: 9/3/87 */

#include "ADglobals.h"
#include "TEKtech.h"
#include "oct.h"
#include <stdio.h>

ROUTvertical( facet )
octObject *facet;
{
	int chycrd, termycrd;
	int lowleftx, lowlefty, uprightx, uprighty;
	int layerwidth;
	char *layername;
	struct _module *tmpmod;
	struct _terminal *tmpterm;


	tmpmod = modlist[ CBLK ];
	for ( ; tmpmod != NULL; tmpmod = tmpmod->next ) {
		tmpterm = tmpmod->terminals;
		for ( ;tmpterm != NULL; tmpterm = tmpterm->next ) {
			if ( tmpterm->chrlayer == 1 ) {
				layerwidth = polywidth;
				layername = botpoly_L;
			}
			else if ( tmpterm->chrlayer == 2 ) {
				layerwidth = metwidth;
				layername = metal_L;
			}
			else {
				fprintf(stderr,"ROUTvertical: internal error\n");
				exit(-1);
			}
						
			lowleftx = PERMfindXcrd( tmpterm ) - layerwidth / 2;
			uprightx = lowleftx + layerwidth;
			if ( tmpterm->channel->name == TOP ) {
			  if ( (chycrd = tmpterm->channel->module->ytrans) > 
			      (termycrd = (tmpterm->ycoord + tmpmod->ytrans)) ) {
			    /*** make the vertical extension */
			    lowlefty = termycrd - layerwidth / 2;
			    uprighty = chycrd + layerwidth / 2;
			    makebox(facet, layername, lowleftx, lowlefty,
				    uprightx, uprighty);
			  }
			}
			else if ( tmpterm->channel->name == BOTTOM ) {
				if ( (chycrd = (tmpterm->channel->module->ytrans + 
											 tmpterm->channel->module->ydim)) < 
						  (termycrd = (tmpterm->ycoord + tmpmod->ytrans)) ) {
					/*** make the vertical extension */
					lowlefty = chycrd - layerwidth / 2;
					uprighty = termycrd + layerwidth / 2;
					makebox(facet, layername, lowleftx, lowlefty,
									   uprightx, uprighty);
				}
			}
		}
	}
}
