#ifndef   _TEKTECH_
#define   _TEKTECH_

/* technology information */

extern char *pwel_L, *nwel_L, *pdif_L, *ndif_L;
extern char *metal_L;
extern char *con_L, *botpoly_L, *toppoly_L;
extern char *cop2_L;
extern char *select_L;
extern char *technName;

extern int uctype; /* type of topplate connection */
extern int shieldflag; /* 1 if shielding is allowed */

extern int resolution; /* minimum resolution of mask generator */
extern int botextop;   /*minimum extension of bottom plate beyond top plate*/
extern int toptopsp;   /*minimum spacing between top plates */
extern int botbotsp;   /*minimum spacing between bottom plates */
extern int mincontd;   /*minimum contact dimension */
extern int metovcont;  /*metal overlap of contact */
extern int metwidth;   /*metal width for interconnects */
extern int metmetsp; /* spacing between adjacent metal lines */
extern int polywidth;  /*minimum bottom plate width for interconnects */
extern int minctctsp;  /*minimum center to center via spacing */

extern int polyndifsp; /* poly to ndiffusion spacing */
extern int polypdifsp; /* poly to pdiffusion spacing */
extern int ndifovcon; /* ndiffusion overlap over contact */
extern int ndifconsp; /* spacing of ndiffusion and contact */
extern int pdifovcon; /* pdiffusion overlap over contact */
extern int pdifconsp; /* spacing of pdiffusion and contact */
extern int polyconsp; /* poly contact spacing */
extern int polypolysp; /* spacing of two poly lines */
extern int polyovcon; /* poly overlap of contact */

extern int pwelovndif; /* pwell overlap over ndiffusion */
extern int pwelovpdif; /* pwell overlap over pdiffusion */
extern int pwelpdifsp; /* pwell and pdiffusion spacing */
extern int pwelpwelsp; /* spacing between pwells */
extern int nwelnwelsp; /* spacing between nwells */

extern int conconsp; /* seperation of two adjacent contacts */
extern int topconsp; /* seperation of top plate and contact */
					/* used for shielding only */
extern int selovpdif, selndifsp; /* select line rules */
extern int selchsp; /* spacing of channel and select */

extern int oaxsep; /* average seperation of opamp blocks in x direction */
extern int swxsep; /* x seperation of switches */
extern int blkxsep;
extern int minoverhang; /* minimum overhang of terminals over blocks */

extern int vggwidth; /* width of power busses */

extern int Minside; /* minimum allowable unit capacitor side dimension */
extern double cap_per_ua; /* capacitance per micron squared */

extern int chipxdim; /* the x dimension of the circuit */

#endif
