#include <stdio.h>
#include "oct.h"
#include "oh.h"
#include "ADglobals.h"
#include "TEKtech.h"
#include "vulcan.h"

/* this file contains the modules enhancing the oct commands */
/* also programs for string manipulation */

openfacet(object, cell, view, facet, mode)
octObject *object;
char *cell, *view, *facet, *mode;
{
  octObject prop;

  OH_ASSERT( ohOpenFacet(object, cell, view, facet, mode));

  if(mode[0] == 'w') {
    ohCreatePropStr(object, &prop, "TECHNOLOGY", technName);
    ohCreatePropStr(object, &prop, "VIEWTYPE",   "PHYSICAL");
    ohCreatePropStr(object, &prop, "EDITSTYLE",  "PHYSICAL");
    ohCreatePropStr(object, &prop, "CELLCLASS",   "MODULE");
  }
}

octObject *makebox(facet,layername,lowleftx,lowlefty,uprightx,uprighty)
octObject *facet;
char *layername;
int lowleftx, lowlefty, uprightx, uprighty;
{
    octObject layer;
    octObject box;

    LAMBDA_ROUND(lowleftx);
    LAMBDA_ROUND(lowlefty);
    LAMBDA_ROUND(uprightx);
    LAMBDA_ROUND(uprighty);

    layer.type = OCT_LAYER;
    layer.contents.layer.name = layername;

    OH_ASSERT( octGetOrCreate(facet, &layer));
    OH_ASSERT( ohCreateBox(facet,&box,lowleftx,lowlefty,uprightx,uprighty));
    OH_ASSERT( octAttach(&layer,&box));

    return( &box );

}

static char
*myCorrection(name)
char  *name;
{
  int  i;

  for(i=0 ; name[i]!='\0' ; i++)
    if(name[i] == '/')
      return (name+i+1);
  return name;
}

makeinstance(facet, name, master, view, transformtype, xtrans, ytrans)
octObject       *facet;
char *name,     *master, *view;
octTransformType transformtype;
int              xtrans, ytrans;
{
    octObject instance;
    OH_ASSERT( ohCreateInstance(facet, &instance, name, master, view,
				xtrans, ytrans, transformtype));
}

/* creates a formal terminal and attaches a box geometry to it */
makefterm(facet_con, name, box)
octObject *facet_con;
char *name; /* name of the terminal */
octObject *box;
{
    octObject fterminal; /* the formal termianl */
    octObject fterm_dir; /* direction property of formal termianl */
    
    if(ohCreateTerm(facet_con, &fterminal, name) < OCT_OK) {
	octError("creating a formal terminal");
	exit(-1);
    }
    
    OH_ASSERT(octAttach(&fterminal,box));
}
